/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the  "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * $Id: IntDate.java 470245 2006-11-02 06:34:33Z minchau $
 */

import java.util.Vector;
import java.lang.Math;
import java.util.Collections;

public class Wilcoxon
{
	public Vector<Vector<Integer>> highest = null; // for each treatment, for each trial, the highest individual


	public Wilcoxon(int nbtreatment, int nbtrials )
	{
		highest = new Vector<Vector<Integer>>();

		for( int i=0 ; i<nbtreatment; i++ )
		{
			highest.add( new Vector<Integer>() );
			for( int j=0 ; j<nbtrials; j++ )
			{
				highest.get(i).add( 0 );
			}
		}

	}
	public String ajouterListe(int fitness, int treatment, int trial)
    {	  
	   if( highest.get(treatment).get(trial) < fitness )
	   {
			highest.get(treatment).set(trial,fitness);
	   }
	   return "";
    }
	public String getresult()
	{
System.out.println("best:");
		String s = "W = ";
	/*	System.out.println("best:");
		for( int i=0 ; i<highest.size(); i++ )
		{
			System.out.println("trial "+i);
			for( int j=0 ; j<highest.get(i).size(); j++ )
			{
				System.out.println("treatment "+j+" - best is "+highest.get(i).get(j));
				
			}
		} */

		// compare first and second trial only :	
		Vector<Integer> sub = new Vector<Integer>();
		for( int j=0 ; j<highest.get(0).size(); j++ )
		{
			int dif =  highest.get(1).get(j) - highest.get(0).get(j);
			if(dif != 0)
				sub.add( dif );
		}	
		// valeur absolue :
		Vector<Integer> absolute = new Vector<Integer>();
		for(int i=0; i<sub.size(); i++ )
		{
			absolute.add( Math.abs(sub.get(i)) );
		}
		// triage
		Collections.sort( absolute );

		// calcul :
		int W = 0;
		for( int i=0; i< absolute.size() ; i++ )
		{
			// recherche la valeur et regarde si negatif ou positif :
			int absval = absolute.get(i);
			// parcourt le tableau original :
			for( int j=0; j< sub.size(); j++ )
			{
				if( absval == sub.get(j) )
				{
					W += i;
					sub.set(j,0);
				}
				if( absval == 0 - sub.get(j) )
				{
					W -= i;
					sub.set(j,0);
				}
			}
		}
		s += W;
		s += " N = "+absolute.size();
		return s;
	}

}










