<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/Graphics/SVG/SVG-19990812.dtd">

<xsl:output method="xml" indent="yes" media-type="image/svg"/>

<xsl:template name="line" >
	<xsl:param name="x1" />
	<xsl:param name="y1" />
	<xsl:param name="x2" />
	<xsl:param name="y2" />
	<line x1="{$x1}" x2="{$y1}" y1="{$x2}" y2="{$y2}"/>
</xsl:template>

<xsl:template match="/">

<svg width = "3in" height="3in">
    <g style = "stroke: #000000"> 
        <!-- draw the axes -->
		<xsl:call-template name="line" > <!-- horizontal -->
			<xsl:with-param name="x1" select="10" />
			<xsl:with-param name="y1" select="150" />
			<xsl:with-param name="x2" select="150" />
			<xsl:with-param name="y2" select="150" />
		</xsl:call-template>
        <text x="0" y="10">Fitness</text>
		<xsl:call-template name="line" > <!-- vertical -->
			<xsl:with-param name="x1" select="10" />
			<xsl:with-param name="y1" select="10" />
			<xsl:with-param name="x2" select="10" />
			<xsl:with-param name="y2" select="150" />
		</xsl:call-template>
        <text x="150" y="165">Generation</text>


        <xsl:for-each select="sales/division">
            <!-- define some useful variables -->

            <!-- the bar's x position -->
            <xsl:variable name="pos"
                          select="(position()*40)-30"/>

            <!-- the bar's height -->
            <xsl:variable name="height"
                          select="revenue*10"/>

            <!-- the rectangle -->
            <rect x="{$pos}" y="{150-$height}"
                  width="20" height="{$height}"/>

            <!-- the text label -->
            <text x="{$pos}" y="165">
                <xsl:value-of select="@id"/>
            </text> 

            <!-- the bar value -->
            <text x="{$pos}" y="{145-$height}">
                <xsl:value-of select="revenue"/>
            </text>
        </xsl:for-each>
    </g>
</svg>

</xsl:template>
</xsl:stylesheet>




<!--
	<xsl:template match="CalculTotal" >
		<xsl:param name="listeIndi" />
		<xsl:choose>
		 <xsl:when test="$listeIndi">
		  <xsl:variable name="note"
				   select="$listeIndi[1]"/>
			<xsl:variable name="autresNotes">
			 <xsl:call-template name="CalculTotal">
				<xsl:with-param name="listeIndi"
				  select="$listeIndi[position() != 1]"/>
			 </xsl:call-template>
		  </xsl:variable>
		  <xsl:value-of select="$note + $autresNotes"/>
		 </xsl:when>
		 <xsl:otherwise>0</xsl:otherwise>
		</xsl:choose>
	</xsl:template>


	<xsl:template match="generation">
	 <xsl:variable name="total">
		<xsl:call-template name="CalculTotal">
		  <xsl:with-param name="listeIndi"
		         select="descendant::individual"/>
		  </xsl:call-template>
		</xsl:variable>
		<xsl:value-of
		   select="$total div count(NOTES/NOTE)"/>
	</xsl:template>



-->
<!--	<xsl:template name="sumfitness">
	  <xsl:param name="current"/>
	  <xsl:if test="$n &lt;= $max">
		 Elément <xsl:value-of select="$n"/> :
	
	  <xsl:call-template name="AfficheElement">
	  <xsl:with-param name="n" select="$n + 1"/>
	  <xsl:with-param name="max" select="$max"/>
	 </xsl:call-template>
	 </xsl:if>
	</xsl:template>
-->

<!--	<xsl:template match="/" >
		<xsl:variable name="nbgen" select="count(descendant::generation)" />
		<xsl:variable name="nbindiv" select="count(descendant::individual)" />
		Il y a <xsl:value-of select="$nbgen" /> generations
		avec <xsl:value-of select="$nbindiv div $nbgen" /> individus par generation.
		
		<xsl:call-template name="AfficheElement" >
			<xsl:with-param name="n" select="1"/>
			<xsl:with-param name="max" select="100"/>
		</xsl:call-template>

		<xsl:apply-templates match="descendant::generation" />

	</xsl:template>		
-->
<!--	<xsl:template match="generation" >
	
		Generation : <xsl:value-of select="@id" /> mean fitness = <xsl:value-of select="sum(descendant::individual)" />
			
			<xsl:apply-templates select="descendant::individual" />
	</xsl:template>	

	<xsl:template match="individual">
	Individu <xsl:value-of select="@id" /> Fitness : <xsl:value-of select="@fitness"/> 
	</xsl:template>
-->


http://chart.apis.google.com/chart
	?chxl=1:|Generation|3:|Fitness
	&#38;chxp=1,5|3,100
	&#38;chxr=0,0,<xsl:value-of select="$nbgen" />,1|1,0,5
	&#38;chxs=0,676767,11.5,0,lt,676767
	&#38;chxt=x,x,y,y
	&#38;chs=500x500
	&#38;cht=lc
	&#38;chco=3D7930,FF9900,FF0000
	&#38;chd=t:<xsl:apply-templates select="descendant::generation" mode="moyenne" ><xsl:with-param name="nbgen" select="$nbgen" /></xsl:apply-templates> |<xsl:apply-templates select="descendant::generation" mode="best" ><xsl:with-param name="nbgen" select="$nbgen" /></xsl:apply-templates>
|<xsl:apply-templates select="descendant::generation" mode="mediane" ><xsl:with-param name="nbgen" select="$nbgen" /></xsl:apply-templates> 
	&#38;chdl=medium+fitness|best+fitness|mediane+fitness   
 	&#38;chg=20,5,0,0
    &#38;chls=2,4,0
    &#38;chtt=Evolution+of+Fitness+with+generation
